#!/bin/sh
DIR=$(cd $(dirname $0) && pwd)
cd ${DIR}
loop=5
count=0
fail=0
fail_limit=2
rm -rf /userdata/audio_test_result/
mkdir -p /userdata/audio_test_result
while [ ${count} -lt ${loop} ]
do
count=$((count + 1))
tinymix set 28 30
rm /userdata/audio_test_result/audio_result.wav
tinycap /userdata/audio_test_result/audio_result.wav -c 8 -r 44100 -b 16 -t 3 -D 0 -d 0 &
tinyplay ./test_1000_16bit.wav -D 0 -d 1
sleep 1.5
./audio_loop_test --cf /userdata/audio_test_result/audio_result.wav --ld ./libfftw3f.so.3.5.8 -f 1000 -t 0.1 -p 5 -a 1 -k 0.1 --th 0.5 --cm 255
result=$?
if [ ${result} -eq 255 ];then
    echo "loop: ${count} succeed!!!"
    echo "loop: ${count} succeed!!!" >> /userdata/audio_test_result/result.log
else
    echo "loop: ${count} failed， result = ${result}"
    echo "loop: ${count} failed， result = ${result}" >> /userdata/audio_test_result/result.log
    cp /userdata/audio_test_result/audio_result.wav /userdata/audio_test_result/audio_result-${fail}.wav
    fail=$((fail + 1))
    if [ ${fail} -eq ${fail_limit} ];then
        break
    fi
fi
rm /userdata/audio_test_result/audio_result.wav
done