#!/bin/sh

# run.sh [config/rerun/see/clean/disclean] [outpath]

PATH=`pwd`:$PATH; export PATH
OS=aarch64-linux-gnu; export OS

if [ "$1" = "clean" ]; then
    echo "clean lmbench results ..."
    rm -f ../results/*.out
    rm -f ../results/*.errs
    rm -f ../results/*.perc
    rm -f ../results/${OS}/*
    exit 0
fi

if [ "$1" = "disclean" ]; then
    echo clean lmbench results and config ...
    rm -f ../results/*.out
    rm -f ../results/*.errs
    rm -f ../results/*.perc
    rm -f ../results/${OS}/*
    rm -f ../bin/${OS}/CONFIG.*
    exit 0
fi

CONFIG=`ls ../bin/${OS} |grep CONFIG`
if [ "$1" = "config" ] || [ -z "${CONFIG}" ]; then
    config-run
    sed -e 's/MAIL=yes/MAIL=no/g' -i ../bin/${OS}/CONFIG.*
fi

if [ -z "$1" ] || [ "$1" = "rerun" ]; then
    results
fi

if [ "$1" = "see" ]; then
    PWD_SAVE=`pwd`; cd ../results
    LIST=`getlist`
    if [ ! -z "$2" ]; then
        SOUT=$2.summary
        POUT=$2.percent
    else
        SOUT=../results/summary
    fi
    getsummary ${LIST} >${SOUT}.out 2>${SOUT}.errs
    #getpercent ${LIST} >${POUT}.out 2>${POUT}.errs
    percent ${SOUT}.out >${SOUT}.perc
    cd ${PWD_SAVE}
fi

