JudgeTestPattern()
{
		#$1 file name
		#$2 match string
		#$3 offset
        if [ $# -ne 3 ];then
                echo "Function Called Wrong"
                return 1
        fi
        if [ ! -f $1 ];then
                echo "File is not exist"
                return 2
        fi
        hexdump -C $1 -s $3 -n 16|grep "$2" 2>&1 > /dev/null
        if [ $? -ne 0 ];then
              echo "$1 offset $3 data not match $2" 2>&1 > /dev/null
			  return 3
        else
              return 0
        fi
		
		return 0
}


#$1 how many testpattern to be tested
#$2 how many seconds does a process run, at least 5 seconds
#$3 testpattern fps
if [ ! -f vio_test ];then
	echo "Error: make sure vio_test and this script in the same directory"
	exit 1
fi

if [ $# -ne 3 ];then
	echo "invalid arguments"
	echo "Usage: $0 [process_num] [run_seconds] [testpattern fps]"
	exit 1
fi

tc_log_file="./tc_log.txt"
echo "run $1 processes" |tee $tc_log_file
if [ $1 -gt 8 ];then
	echo "invalid arguments"
	exit 1
fi

for index in `seq 0 7`
do
	if [ $index -lt $1 ];then
		case $index in
			0)
			./vio_test -v ./cfg/pattern_sif_offline_isp_ipu_online_1920x1080_Pipeline0.json -r $2 -p 1 -M 1 -c 0 -t 128 -l 0 -m 1 -f 1 -g 1 -d 1 2>&1 > group0_log.txt &
			echo "process 1 running" >> $tc_log_file
			;;
			1)
			./vio_test -v ./cfg/pattern_sif_offline_isp_ipu_online_1920x1080_Pipeline1.json -r $2 -p 2 -M 2 -c 0 -t 128 -l 0 -m 1 -f 1 -g 1 -d 1 2>&1 > group1_log.txt &
			echo "process 2 running" >> $tc_log_file
			;;
			2)
			./vio_test -v ./cfg/pattern_sif_offline_isp_ipu_online_1920x1080_Pipeline2.json -r $2 -p 3 -M 4 -c 0 -t 128 -l 0 -m 1 -f 1 -g 1 -d 1 2>&1 > group2_log.txt &
			echo "process 3 running" >> $tc_log_file
			;;
			3)
			./vio_test -v ./cfg/pattern_sif_offline_isp_ipu_online_1920x1080_Pipeline3.json -r $2 -p 4 -M 8 -c 0 -t 128 -l 0 -m 1 -f 1 -g 1 -d 1 2>&1 > group3_log.txt &
			echo "process 4 running" >> $tc_log_file
			;;
			4)
			./vio_test -v ./cfg/pattern_sif_offline_isp_ipu_online_1920x1080_Pipeline4.json -r $2 -p 5 -M 16 -c 0 -t 128 -l 0 -m 1 -f 1 -g 1 -d 1 2>&1 > group4_log.txt &
			echo "process 5 running" >> $tc_log_file
			;;
			5)
			./vio_test -v ./cfg/pattern_sif_offline_isp_ipu_online_1920x1080_Pipeline5.json -r $2 -p 6 -M 32 -c 0 -t 128 -l 0 -m 1 -f 1 -g 1 -d 1 2>&1 > group5_log.txt &
			echo "process 6 running" >> $tc_log_file
			;;
			6)
			./vio_test -v ./cfg/pattern_sif_offline_isp_ipu_online_1920x1080_Pipeline6.json -r $2 -p 7 -M 64 -c 0 -t 128 -l 0 -m 1 -f 1 -g 1 -d 1 2>&1 > group6_log.txt &
			echo "process 7 running" >> $tc_log_file
			;;
			7)
			./vio_test -v ./cfg/pattern_sif_offline_isp_ipu_online_1920x1080_Pipeline7.json -r $2 -p 8 -M 128 -c 0 -t 128 -l 0 -m 1 -f 1 -g 1 -d 1 2>&1 > group7_log.txt &
			echo "process 8 running" >> $tc_log_file
			;;				
		esac
	fi
done

wait_time=`expr $2 + 10`
echo "wait $wait_time seconds for all process done" |tee -a $tc_log_file
sleep $wait_time

ps |grep vin_vps_test |grep -v grep
if [ $? -ne 0 ];then #still runnig
	echo "processes are done" |tee -a $tc_log_file
else
	echo "process are still running, abnormal" |tee -a $tc_log_file
	exit 2
fi

sync

echo "check if dump files are ok" >> $tc_log_file
group_num_max=`expr $1 - 1`
for i in `seq 0 $group_num_max`
do
	#skip first several frames because they are not statble
	file_name="s"$i"_pym_out_basic_layer_25_DS0_1920_1080.yuv"
	echo "jude file $file_name" >> $tc_log_file
	ls *.yuv|grep $file_name
	if [ $? -ne 0 ];then
		echo "Error:process $i has no dump yuv file" |tee -a $tc_log_file
		exit 3
	fi
	
	#now check if testpattern is corresponding data
	testpattern_type=`expr $i % 4`
	#type 0 offset 4 
	#type 1 has first 60 byte zero and others none zero afterwards
	#type 2 has 0x7e18 bytes zero and others none zero afterwards
	#type 3 has no zero at beginning
	
	if [ $testpattern_type -eq 3 ];then
		#testpattern_type 3 first 16bytes is not zero
		JudgeTestPattern $file_name "00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00" 4
		if [ $? -ne 0 ];then
			echo "Sucess:process $i data type $testpattern_type is OK" |tee -a $tc_log_file
		fi
	else
		#type 0 1 2 first 16 bytes is zero
		JudgeTestPattern $file_name "00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00" 4
		if [ $? -ne 0 ];then
			echo "Error:process $i data type $testpattern_type is Wrong" |tee -a $tc_log_file
			exit 3
		else
			if [ $testpattern_type -eq 0 ];then
				JudgeTestPattern $file_name "00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00" 0x3d40
				if [ $? -eq 0 ];then
					JudgeTestPattern $file_name "00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00" 0x7e18
					if [ $? -eq 0 ];then
						echo "Sucess:process $i data type $testpattern_type is OK"  |tee -a $tc_log_file
					else
						echo "Error:process $i data type $testpattern_type is Wrong" |tee -a $tc_log_file
						exit 3
					fi
				else
					echo "Error:process $i data type $testpattern_type is Wrong" |tee -a $tc_log_file
					exit 3
				fi
			elif [ $testpattern_type -eq 1 ];then
				JudgeTestPattern $file_name "00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00" 0x3d40
				if [ $? -ne 0 ];then
					JudgeTestPattern $file_name "00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00" 0x7e18
					if [ $? -ne 0 ];then
						echo "Sucess:process $i data type $testpattern_type is OK"  |tee -a $tc_log_file
					else
						echo "Error:process $i data type $testpattern_type is Wrong" |tee -a $tc_log_file
						exit 3
					fi
				else
					echo "Error:process $i data type $testpattern_type is Wrong" |tee -a $tc_log_file
					exit 3
				fi
			elif [ $testpattern_type -eq 2 ];then
				JudgeTestPattern $file_name "00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00" 0x3d40
				if [ $? -eq 0 ];then
					JudgeTestPattern $file_name "00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00" 0x7e18
					if [ $? -ne 0 ];then
						echo "Sucess:process $i data type $testpattern_type is OK"  |tee -a $tc_log_file
					else
						echo "Error:process $i data type $testpattern_type is Wrong" |tee -a $tc_log_file
						exit 3
					fi
				else
					echo "Error:process $i data type $testpattern_type is Wrong" |tee -a $tc_log_file
					exit 3
				fi
			fi
		fi
	fi
done

exit 0
